SystemOrganization addCategory: #ConfigurationOfUnicode!

Object subclass: #ConfigurationOfUnicode
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfUnicode'!

!ConfigurationOfUnicode commentStamp: 'SvenVanCaekenberghe 1/26/2016 20:00' prior: 0!
The Pharo Unicode project.

	ConfigurationOfUnicode load.
	ConfigurationOfUnicode loadBleedingEdge.
	
Part of the Pharo Unicode project (http://unicode.pharo.org). Copyright (C) 2015, 2016 the Pharo Unicode contributors (Sven Van Caekenberghe, Henrik Sperre Johansen). Licensed under the MIT license (https://en.wikipedia.org/wiki/MIT_License) and for usage within Pharo (http://pharo.org).!

!ConfigurationOfUnicode class methodsFor: 'development support' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfUnicode class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfUnicode class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/26/2016 14:17'!
catalogDescription
	^ 'The Pharo Unicode project'! !

!ConfigurationOfUnicode class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/26/2016 14:17'!
catalogKeywords
	^ #(uncode string character)! !

!ConfigurationOfUnicode class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfUnicode class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfUnicode class methodsFor: 'metacello tool support' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfUnicode class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/26/2016 14:19'!
license
	^ 'The MIT License (MIT)
Copyright (C) 2015, 2016 the Pharo Unicode contributors (Sven Van Caekenberghe, Henrik Sperre Johansen)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'! !

!ConfigurationOfUnicode class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfUnicode class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfUnicode class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfUnicode class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
project

	^self new project! !

!ConfigurationOfUnicode class methodsFor: 'development support' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfUnicode methodsFor: 'baselines' stamp: 'SvenVanCaekenberghe 1/26/2016 14:23'!
baseline1: spec
	<version: '1-baseline'>
	
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/Pharo/Unicode/main/';
			package: 'Unicode-Character-Data';
			package: 'Unicode-Tests-Character-Data' with: [ spec requires: 'Unicode-Character-Data' ];
			group: 'default' with: #('Unicode-Character-Data' 'Unicode-Tests-Character-Data');
			group: 'Core' with: #('Unicode-Character-Data');
			group: 'Tests' with: #('Unicode-Tests-Character-Data') ]! !

!ConfigurationOfUnicode methodsFor: 'baselines' stamp: 'SvenVanCaekenberghe 1/26/2016 15:32'!
baseline2: spec
	<version: '2-baseline'>
	
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/Pharo/Unicode/main/';

			package: 'Unicode-Character-Data';
			package: 'Unicode-Stream-Support';
			package: 'Unicode-Casing' with: [ 
				spec requires: #('Unicode-Character-Data'  'Unicode-Stream-Support') ];
			package: 'Unicode-Normalization' with: [ 
				spec requires: #('Unicode-Character-Data' 'Unicode-Stream-Support') ];

			package: 'Unicode-Tests-Character-Data' with: [ 
				spec requires: 'Unicode-Character-Data' ];
			package: 'Unicode-Tests-Casing' with: [ 
				spec requires: 'Unicode-Casing' ];
			package: 'Unicode-Tests-Normalization' with: [ 
				spec requires: 'Unicode-Normalization' ];

			group: 'default' with: #(
				'Unicode-Character-Data' 'Unicode-Casing' 'Unicode-Stream-Support' 'Unicode-Normalization'
				'Unicode-Tests-Character-Data' 'Unicode-Tests-Casing' 'Unicode-Tests-Normalization');
			group: 'Core' with: #(
				'Unicode-Character-Data' 'Unicode-Casing' 'Unicode-Stream-Support' 'Unicode-Normalization');
			group: 'Tests' with: #(
				'Unicode-Tests-Character-Data' 'Unicode-Tests-Casing' 'Unicode-Tests-Normalization') ]! !

!ConfigurationOfUnicode methodsFor: 'baselines' stamp: 'SvenVanCaekenberghe 1/26/2016 19:21'!
baseline3: spec
	<version: '3-baseline'>
	
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/Pharo/Unicode/main/';

			package: 'Unicode-Character-Data';
			package: 'Unicode-Stream-Support';
			package: 'Unicode-Casing' with: [ 
				spec requires: #('Unicode-Character-Data' 'Unicode-Stream-Support') ];
			package: 'Unicode-Normalization' with: [ 
				spec requires: #('Unicode-Character-Data' 'Unicode-Stream-Support') ];

			package: 'Unicode-Tests-Character-Data' with: [ 
				spec requires: 'Unicode-Character-Data' ];
			package: 'Unicode-Tests-Casing' with: [ 
				spec requires: 'Unicode-Casing' ];
			package: 'Unicode-Tests-Normalization' with: [ 
				spec requires: 'Unicode-Normalization' ];

			group: 'default' with: #('Core' 'Tests');
			
			group: 'Core' with: #(
				'Unicode-Character-Data' 'Unicode-Casing' 'Unicode-Stream-Support' 'Unicode-Normalization');
			group: 'Tests' with: #(
				'Unicode-Tests-Character-Data' 'Unicode-Tests-Casing' 'Unicode-Tests-Normalization') ]! !

!ConfigurationOfUnicode methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/26/2016 14:16'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfUnicode methodsFor: 'symbolic versions' stamp: 'SvenVanCaekenberghe 1/29/2016 11:23'!
stable: spec
	<symbolicVersion: #'stable'>
	
	spec for: #common version: '5'! !

!ConfigurationOfUnicode methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 1/26/2016 14:24'!
version1: spec
	<version: '1' imports: #('1-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			package: 'Unicode-Character-Data' with: 'Unicode-Character-Data-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Character-Data' with: 'Unicode-Tests-Character-Data-SvenVanCaekenberghe.1' ]! !

!ConfigurationOfUnicode methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 1/26/2016 19:59'!
version2: spec
	<version: '2' imports: #('2-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			
			package: 'Unicode-Character-Data' with: 'Unicode-Character-Data-SvenVanCaekebenberghe.3';
			package: 'Unicode-Stream-Support' with: 'Unicode-Stream-Support-SvenVanCaekenberghe.1';
			package: 'Unicode-Casing' with: 'Unicode-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Normalization' with: 'Unicode-Normalization-SvenVanCaekenberghe.1';

			package: 'Unicode-Tests-Character-Data' with: 'Unicode-Tests-Character-Data-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Casing' with: 'Unicode-Tests-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Normalization' with: 'Unicode-Tests-Normalization-SvenVanCaekenberghe.1' ]! !

!ConfigurationOfUnicode methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 1/26/2016 19:59'!
version3: spec
	<version: '3' imports: #('2-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			
			package: 'Unicode-Character-Data' with: 'Unicode-Character-Data-SvenVanCaekebenberghe.4';
			package: 'Unicode-Stream-Support' with: 'Unicode-Stream-Support-SvenVanCaekenberghe.1';
			package: 'Unicode-Casing' with: 'Unicode-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Normalization' with: 'Unicode-Normalization-SvenVanCaekenberghe.2';

			package: 'Unicode-Tests-Character-Data' with: 'Unicode-Tests-Character-Data-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Casing' with: 'Unicode-Tests-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Normalization' with: 'Unicode-Tests-Normalization-SvenVanCaekenberghe.1' ]! !

!ConfigurationOfUnicode methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 1/26/2016 19:26'!
version4: spec
	<version: '4' imports: #('3-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			
			package: 'Unicode-Character-Data' with: 'Unicode-Character-Data-SvenVanCaekenberghe.5';
			package: 'Unicode-Stream-Support' with: 'Unicode-Stream-Support-SvenVanCaekenberghe.1';
			package: 'Unicode-Casing' with: 'Unicode-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Normalization' with: 'Unicode-Normalization-SvenVanCaekenberghe.2';

			package: 'Unicode-Tests-Character-Data' with: 'Unicode-Tests-Character-Data-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Casing' with: 'Unicode-Tests-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Normalization' with: 'Unicode-Tests-Normalization-SvenVanCaekenberghe.1' ]! !

!ConfigurationOfUnicode methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 1/29/2016 11:23'!
version5: spec
	<version: '5' imports: #('3-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			
			package: 'Unicode-Character-Data' with: 'Unicode-Character-Data-SvenVanCaekenberghe.7';
			package: 'Unicode-Stream-Support' with: 'Unicode-Stream-Support-SvenVanCaekenberghe.1';
			package: 'Unicode-Casing' with: 'Unicode-Casing-SvenVanCaekenberghe.2';
			package: 'Unicode-Normalization' with: 'Unicode-Normalization-SvenVanCaekenberghe.3';

			package: 'Unicode-Tests-Character-Data' with: 'Unicode-Tests-Character-Data-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Casing' with: 'Unicode-Tests-Casing-SvenVanCaekenberghe.1';
			package: 'Unicode-Tests-Normalization' with: 'Unicode-Tests-Normalization-SvenVanCaekenberghe.2' ]! !
